package inf101.v18.connectfour.events.random;

import inf101.v18.connectfour.board.IVerticalBoard;

/**
 * A random event which can be run on an IVerticalBoard.
 */
public interface IRandomEvent {
    /**
     * Rolls n die, and acts if all die got a "6".
     *
     * @param b The board to act on
     * @param n The number of die
     * @return  True if something happened. False otherwise
     */
    boolean rollDie(IVerticalBoard b, int n);

    /**
     * Flips a coin, and acts if it comes out as head.
     *
     * @param b The board to act on
     * @return  True if somehting happened. False otherwise
     */
    boolean flipCoin(IVerticalBoard b);

    /**
     * An announcement describing what just happened.
     *
     * @return  An announcement string
     */
    String announcement();
}
