package inf101.v18.connectfour.interfaces;

import inf101.v18.connectfour.board.IBoard;
import inf101.v18.connectfour.player.IPlayer;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Implements common variables and methods for any GUI interface.
 */
public abstract class GUI implements ActionListener, IGameInterface {
    final int BUTTON_HEIGHT = 25;
    final int BUTTON_WIDTH = 50;
    final int TILE_HEIGHT = 50;
    final int HEIGHT_GAP = 10;
    final int WIDTH_GAP = 10;

    JButton resetButton;
    JLabel infoLabel;
    JPanel mainPanel;
    JFrame frame;
    IBoard board;

    IPlayer currentPlayer;

    void reset(ActionEvent e) {
        if (e.getSource() == resetButton) {
            board.flush();
            displayBoard();
            currentPlayer = board.nextPlayer();
            displayMessage("It's " + currentPlayer.getName() + "'s turn.");
        }
    }

    @Override
    public boolean hasDrawn() {
        return board.isFull();
    }

    @Override
    public boolean hasWon() {
        return board.won();
    }

    @Override
    public void displayMessage(String s) {
        infoLabel.setText(s);
    }

    @Override
    public void doTurn() {}
}
