package inf101.v18.connectfour.interfaces;

/**
 * Provides an interface a user interface.
 */
public interface IGameInterface {
    /**
     * Displays a message to the player(s).
     *
     * @param s The massage to display
     */
    void displayMessage(String s);

    /**
     * Displays an updated board.
     */
    void displayBoard();

    /**
     * Checks if the game ended in someone winning.
     *
     * @return  True if the game is over
     */
    boolean hasWon();

    /**
     * Checks if the game ended in a draw.
     *
     * @return  True if the game is over
     */
    boolean hasDrawn();

    /**
     *  Makes the interface place an object corresponding to the current player.
     *
     * @param x The x-coordinate of the object to place
     * @param y The y-coordinate of the object to place
     * @return  True if the object was placed
     * @throws  IllegalAccessException If method is used from a vertical interface
     */
    boolean placePlayerObject(int x, int y) throws IllegalAccessException;

    /**
     * Makes the interface do whatever it wants to do for this turn.
     */
    void doTurn();
}
