package inf101.v18.connectfour.interfaces;

/**
 * An IVerticalGameInterface replaces IGameInterface's place method with a drop method.
 */
interface IVerticalGameInterface extends IGameInterface {
    /**
     * Drops an object onto the board at column i,
     *
     * @param i Target column
     * @return  True if the column had available space
     */
    boolean dropObject(int i);

    /**
     * Prevents manually placing a game piece, unless method is overwritten.
     *
     * @param x An integer which doesn't matter
     * @param y An integer which doesn't matter
     * @return  Nothing
     * @throws IllegalAccessException   When method is used from a Vertical game
     */
    default boolean placePlayerObject(int x, int y) throws IllegalAccessException {
        throw new IllegalAccessException("Method not allowed in a vertical board.");
    }
}
