package inf101.v18.connectfour.player;

import inf101.v18.connectfour.board.IBoard;
import inf101.v18.connectfour.board.IVerticalBoard;

/**
 * An IAI is an IPlayer with methods for retrieving its next move.
 */
public interface IAI extends IPlayer {
    /**
     * Gets the column where the AI wants to drop its token.
     *
     * @param b A board
     * @return  A valid column
     */
    int getColumn(IVerticalBoard b);

    /**
     * Gets the x and y coordinate of the board position where the AI wants to place its token.
     *
     * @param b A board
     * @return  An array of integers with length 2
     */
    int[] getXY(IBoard b);
}
