package inf101.v18.connectfour.player;

import java.awt.*;
import java.util.Objects;

/**
 * A class representing a player playing a game.
 */
public class Player implements IPlayer {
    private final String name;
    private final Color color;

    public Player(String name, Color color) {
        if (name == null || name.equals("")) {
            throw new IllegalArgumentException("Player name is invalid.");
        }
        if (color == null) {
            throw new IllegalArgumentException("Player color is invalid");
        }
        this.name = name;
        this.color = color;
    }

    @Override
    public Color getColor() {
        return color;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Player player = (Player) o;
        return Objects.equals(name, player.name) ||
                Objects.equals(color, player.color);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, color);
    }
}
